/* -*- linux-c -*-
 * sysctl_net.c: sysctl interface to net subsystem.
 *
 * Begun April 1, 1996, Mike Shaver.
 * Added /proc/sys/net directories for each protocol family. [MS]
 *
 * $Log: sysctl_net.c,v $
 * Revision 1.1.1.1  2006-12-08 09:15:50  halcyon
 * First import
 *
 * Revision 1.1.1.1  2006/11/09 09:40:50  halcyon
 * First import
 *
 * Revision 1.1.1.1  2006/03/13 10:29:46  jedy
 * new 1029 kernel
 *
 * Revision 1.1.1.1  2006/02/15 03:45:54  jedy
 * kernel
 *
 * Revision 1.1.1.1  2005/01/31 04:26:23  john
 *
 * 1. Linux kernel 2.4.19
 * 2. porting on A320D
 *
 * Revision 1.1.1.1  2005/01/27 09:10:26  john
 *
 * 2. porting on A320D
 *
 * Revision 1.1.1.1  2003/07/18 06:51:08  paulong
 * Imported using TkCVS
 *
 * Revision 1.1.1.1  2003/07/17 12:34:36  paulong
 * Imported using TkCVS
 *
 * Revision 1.1.1.1  2003/07/17 02:36:02  paulong
 * armlinux with PCI/SD/IDE/MAC 20030717
 *
 * Revision 1.2  1996/05/08  20:24:40  shaver
 * Added bits for NET_BRIDGE and the NET_IPV4_ARP stuff and
 * NET_IPV4_IP_FORWARD.
 *
 *
 */

#include <linux/config.h>
#include <linux/mm.h>
#include <linux/sysctl.h>

#ifdef CONFIG_INET
extern ctl_table ipv4_table[];
#endif

extern ctl_table core_table[];

#ifdef CONFIG_NET
extern ctl_table ether_table[], e802_table[];
#endif

#ifdef CONFIG_IPV6
extern ctl_table ipv6_table[];
#endif

#ifdef CONFIG_TR
extern ctl_table tr_table[];
#endif

ctl_table net_table[] = {
	{NET_CORE,   "core",      NULL, 0, 0555, core_table},      
#ifdef CONFIG_NET
	{NET_802,    "802",       NULL, 0, 0555, e802_table},
	{NET_ETHER,  "ethernet",  NULL, 0, 0555, ether_table},
#endif
#ifdef CONFIG_INET
	{NET_IPV4,   "ipv4",      NULL, 0, 0555, ipv4_table},
#endif
#ifdef CONFIG_IPV6
	{NET_IPV6, "ipv6", NULL, 0, 0555, ipv6_table},
#endif
#ifdef CONFIG_TR
	{NET_TR, "token-ring", NULL, 0, 0555, tr_table},
#endif
	{0}
};
