/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#include "ddns_common.h"

/***********************************************************
 * routine: read_ddns_config
 * description: read configuration file from system.conf
 * input: 	config	
 * output:	config
 * return value: DDNS_OK
 *		 DDNS_ERROR
 ***********************************************************/ 	
int read_ddns_config(ddns_param_t *config)
{

	FILE	*fd;
	int retcode = 0;

	//get a file descriptor first and then open system.conf

	fd =  fopen(SYSTEM_CONF,"rt");
	if(fd==NULL){
		retcode = 101;
		goto READ_ERR2;
	}

	memset(config,0,sizeof(ddns_param_t));	
	//retrieve all the data from system.conf

	if(PRO_GetInt(SEC_DDNS, DDNS_MODE , &config->enable, fd) != DDNS_OK){
                retcode = 102;
                goto READ_ERR;
	}
	if(PRO_GetInt(SEC_DDNS, DDNS_SERVICE , &config->server_id, fd) != DDNS_OK){
                retcode = 103;
                goto READ_ERR;
	}
	if(PRO_GetStr(SEC_DDNS, DDNS_ACCOUNT , config->account, DDNS_ACCOUNT_LEN, fd) != DDNS_OK){
                retcode = 104;
                goto READ_ERR;
	}
	if(PRO_GetStr(SEC_DDNS, DDNS_PASSWORD , config->password, DDNS_PASSWORD_LEN, fd) != DDNS_OK){
                retcode = 105;
                goto READ_ERR;
	}
	if(PRO_GetStr(SEC_DDNS, DDNS_HOSTNAME , config->hostname, DDNS_MAX_HOSTNAME_LEN, fd) != DDNS_OK){
                retcode = 106;
                goto READ_ERR;
	}
	if(PRO_GetInt(SEC_DDNS, DDNS_UPDATE_UNIT , &config->schedule, fd) != DDNS_OK){
                retcode = 107;
                goto READ_ERR;
	}
	if(PRO_GetInt(SEC_DDNS, DDNS_UPDATE_PERIOD , &config->interval, fd) != DDNS_OK){
                retcode = 108;
                goto READ_ERR;
	}
	if(PRO_GetInt(SEC_DDNS, DDNS_HOUR , &config->start_hour, fd) != DDNS_OK){
                retcode = 109;
                goto READ_ERR;
	}
	if(PRO_GetInt(SEC_DDNS, DDNS_MINUTE , &config->start_min, fd) != DDNS_OK){
                retcode = 110;
                goto READ_ERR;
	}

READ_ERR:	
	fclose(fd);
READ_ERR2:
	if(retcode){
		//sprintf(logddns1,"read_ddns_config fail ret=%d\n",retcode);
		//log_ddns1(logddns1);
	}
	return retcode;
}

