/***************************************************************
*             Copyright (C) 2003 by SerComm Corp.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#include "ddns_common.h"

#define _DEBUG_

//#define SYSLOG_SECTION		"ez-ipupdate"
//#define SYSLOG_DBG_INDEX	6

#ifdef _DEBUG_
//------------------------------------------------------------
//purpose: Log message to /tmp/ddns.log
//------------------------------------------------------------
static char logddns2[128];
static void log_ddns2(char *s)
{
        FILE *fh;
        fh = fopen("/tmp/ddns.log", "a+");
        if (fh) {
                fprintf(fh, "%s\n", s);
        }
        fclose(fh);
}
#endif

static int check_ddns_hostname(char *p){

	// a-z, A-Z, 0-9
	if ((*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39))
	{
		p++;
	}
	else
	{
		return DDNS_ERROR;
	}

	// a-z, A-Z, 0-9, _, .
	while((*p) !='\0'){
		//if( (*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39) || (*p == 0x5f) || (*p == 0x20) ) {
		if ((*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39) || (*p == 0x2d) || (*p == 0x2e)) {
			 	p++;
		}
		else{
			return DDNS_ERROR;
		}
	 }

	p--;
	// a-z, A-Z, 0-9	
	if ((*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39))
	{
		return DDNS_OK;
	}
	else
	{
		return DDNS_ERROR;
	}
}

#if 0
static int check_ddns_input(char *p){

	while((*p) !='\0'){
		if( (*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39) || (*p == 0x5f) ){
			 	p++;
		}
		else{
			return DDNS_ERROR;
		}
	 }
	 return DDNS_OK;

}

#ifdef _HAVE_TZO_
static int check_ddns_account(char *p){

	while((*p) !='\0'){
		if( (*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39) || (*p == 0x5f) || (*p == 0x2d) || (*p == 0x2e) || (*p == 0x40) ){
			 	p++;
		}
		else{
			return DDNS_ERROR;
		}
	 }
	 return DDNS_OK;

}
#endif

#endif

/***********************************************************
 * routine: write_ddns_config
 * description: write configuration file to system.conf 
 *		and del crontab entry / add DDNS_BINARY 
 * input: 	config	
 * output:	config
 * return value: DDNS_OK
 *		 DDNS_ERROR
 ***********************************************************/ 	
int write_ddns_config(ddns_param_t *config)
{
	int retcode = 0;
	// initialize the structure
	SchdInfo_t info={
			{DDNS_BINARY},			//command
			//interval	    //start		//stop
			{SCHD_DONTCARE , SCHD_DONTCARE, SCHD_DONTCARE},		//week
			{SCHD_DONTCARE , SCHD_DONTCARE, SCHD_DONTCARE},		//month
			{SCHD_DONTCARE , SCHD_DONTCARE, SCHD_DONTCARE},		//day
			{SCHD_DONTCARE , SCHD_DONTCARE, SCHD_DONTCARE},		//hour
			{SCHD_DONTCARE , SCHD_DONTCARE, SCHD_DONTCARE},		//min
			};
#if 0
#ifdef _HAVE_TZO_
	if(check_ddns_account(config->account) != DDNS_OK ){
#else		
	if(check_ddns_input(config->account) != DDNS_OK ){
#endif		
		AddLog(SYSLOG_SECTION, SYSLOG_ALL, SYSLOG_DBG_INDEX);
		return DDNS_ERROR;
	}

	if(check_ddns_input(config->password) != DDNS_OK ){
		AddLog(SYSLOG_SECTION, SYSLOG_ALL, SYSLOG_DBG_INDEX);
		return DDNS_ERROR;
	}

#endif
	if(check_ddns_hostname(config->hostname) != DDNS_OK ){
        retcode = 201;
        goto WRITE_ERR;
	}
	// first determine if the enable flag is on or off 
	if(config->enable) // == ENABLE)
	{

		// remove crontab entry from the list
		/* ---- Del DDNS_BINARY entry from crontab ---- */
		SCHDDelScheduleByCmd(&info);
	
		// write all the data to system.conf
		if(PRO_SetInt(SEC_DDNS, DDNS_MODE , config->enable, SYSTEM_CONF) != DDNS_OK)
		{
	                retcode = 201;
        	        goto WRITE_ERR;
		}
		if(PRO_SetInt(SEC_DDNS, DDNS_SERVICE , config->server_id, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 202;
                        goto WRITE_ERR;
                }
		if(PRO_SetStr(SEC_DDNS, DDNS_ACCOUNT , config->account, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 203;
                        goto WRITE_ERR;
                }
		if(PRO_SetStr(SEC_DDNS, DDNS_PASSWORD , config->password, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 204;
                        goto WRITE_ERR;
                }
		if(PRO_SetStr(SEC_DDNS, DDNS_HOSTNAME , config->hostname, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 205;
                        goto WRITE_ERR;
                }
		if(PRO_SetInt(SEC_DDNS, DDNS_UPDATE_UNIT , config->schedule, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 206;
                        goto WRITE_ERR;
                }
		if(PRO_SetInt(SEC_DDNS, DDNS_UPDATE_PERIOD , config->interval, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 207;
                        goto WRITE_ERR;
                }
		if(PRO_SetInt(SEC_DDNS, DDNS_HOUR , config->start_hour, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 208;
                        goto WRITE_ERR;
                }
		if(PRO_SetInt(SEC_DDNS, DDNS_MINUTE , config->start_min, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 209;
                        goto WRITE_ERR;
                }
#if 0
                if(PRO_SetStr(SEC_DDNS, DDNS_IPADDR , config->outip, SYSTEM_CONF) != DDNS_OK)
		        return DDNS_ERROR;
#endif
		
		// Write entry of DDNS_BINARY to crontab according to the 
		// start_hour & start_min
		// for example, if we want to start the ddns update from 
		// 13:00 , we will write an entry for executing DDNS_BINARY
		// at 12:59 so that the ez-ipupdate will work at 13:00 

		if(config->start_min == 0)
		{
			info.min.start = 59 ;	
	
			if(config->start_hour == 0)
			{
				info.hour.start = 23;	
			}
			else  
			{
			info.hour.start = (config->start_hour)-1;		
			}
		}
		else
		{
			info.min.start = config->start_min-1;
			info.hour.start = config->start_hour;			
		}

		//write DDNS_BINARY into crontab
		// SCHDAddSchedule(&info);
	}
	else  // disable flag is on
	{
		// only set disable to system.conf
		if(PRO_SetInt(SEC_DDNS, DDNS_MODE , config->enable, SYSTEM_CONF) != DDNS_OK)
                {
                        retcode = 210;
                        goto WRITE_ERR;
                }
	
		SCHDDelScheduleByCmd(&info);
		// remove crontab entry from the list
		/* ---- Del ez-ipudate entry from crontab ---- */
		//strcpy(info.command,DDNS_BINARY);
		//SCHDDelScheduleByCmd(&info);
	}
	/* ---- Del ez-ipudate entry from crontab ---- */
	strcpy(info.command,DDNS_BINARY);
	SCHDDelScheduleByCmd(&info);

WRITE_ERR:
        if(retcode){
                sprintf(logddns2,"write_ddns_config fail ret=%d\n",retcode);
                log_ddns2(logddns2);
        }

	return retcode;
}

