#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include "system_def.h"
//#include "event_config.h"
//#include "web_config.h"
#include "PRO_file.h"
#include "schedule.h"
//#include "IMG_conf.h"
//#include "mot_conf.h"

#include "conf_sec.h"


#define SEPERATOR	'\t'	// The seperator used in javascript

/*
 * check current time to determine if now is in schedule or not
 * @return      0 out schedule time
 *              1 in schedule time
 */
int schedule_chk(int type)
{

    FILE *fp = NULL;
    time_t now;
    struct tm *check;
    int insche = 0;
    int stime, etime, ntime;
    int i = 0;
    int enable=0;
    char sch_item[64];
#ifdef _SC_SCHEDULE_NULL_IS_ALL_
    int num_sch =0;
#endif
	//Suzhou update for mend schedule check solution
    char sect_name[MAX_SECTION_LEN+1]={0};
    char key_format[MAX_KEY_LEN+1]={0};
    char schedule[SCH_LEN+1] = {0};
#if 0
    char schedule[SCH_ITEM][SCH_LEN];
    memset(schedule,0,SCH_ITEM*SCH_LEN);
#endif
    fp = fopen(SYSTEM_CONF, "r+");
    if (fp == NULL) 
    {
        return SYSTEM_ERROR;
    }

    /* obtain some necessary information first */
    if(type == SCHD_ALERT) 
    {
        PRO_GetInt(SEC_EVENT, EVENT_SCHEDULE, &enable, fp);
		
	//Suzhou update for mend schedule check solution
        strncpy(sect_name,SEC_EVENT,MAX_SECTION_LEN);
        sect_name[MAX_SECTION_LEN]=0;
        strncpy(key_format,EVENT_NAME_FORMAT,MAX_KEY_LEN);
        sect_name[MAX_KEY_LEN]=0;
#if 0   
        for(i = 1; i <= SCH_ITEM; i++) 
        {
            sprintf(sch_item,EVENT_NAME_FORMAT,i);
            PRO_GetStr(SEC_EVENT, sch_item, schedule[i-1], SCH_LEN, fp);
        }
#endif       

    }
    else if(type == SCHD_ACCESS) 
    {
        PRO_GetInt(SEC_VIDEO, VIDEO_SCH, &enable, fp);
	//Suzhou update for mend schedule check solution
        strncpy(sect_name,SEC_VIDEO,MAX_SECTION_LEN);
        sect_name[MAX_SECTION_LEN]=0;
        strncpy(key_format,VIDEO_NAME_FORMAT,MAX_KEY_LEN);
        sect_name[MAX_KEY_LEN]=0;
#if 0   
        for(i = 1; i <= SCH_ITEM; i++) 
        {
            sprintf(sch_item,VIDEO_NAME_FORMAT,i);
            PRO_GetStr(SEC_VIDEO, sch_item, schedule[i-1], SCH_LEN, fp);
        }
#endif        
    }
    else if(type == SCHD_NVSION) 
    {
        /* Reserved */
    }


    if (enable == ALWAYS_ON) 
    {
        fclose(fp);
        return 1;
    }

#if 0
    fclose(fp);
#endif
    now = time(NULL);
    check = localtime(&now);
    ntime = check->tm_hour * 60 + check->tm_min;

    /* parsing schedule */
    for(i = 0; i < SCH_ITEM; i++) 
    {
        unsigned int days, shr, ehr, smn, emn;

	//Suzhou update for mend schedule check solution
        memset(schedule,0,SCH_LEN+1);
        sprintf(sch_item,key_format,i);
        PRO_GetStr(sect_name, sch_item, schedule, SCH_LEN, fp);
        if(strlen(schedule) == 0)
#if 0
        if(strlen(schedule[i]) == 0)
#endif
        {
            continue;
        }
#ifdef _SC_SCHEDULE_NULL_IS_ALL_
        num_sch++;
#endif
	//Suzhou update for mend schedule check solution
        sscanf(schedule, "%1u,%2u:%2u,%2u:%2u", &days,&shr, &smn, &ehr, &emn);
#if 0
        sscanf(schedule[i], "%1u,%2u:%2u,%2u:%2u", &days,&shr, &smn, &ehr, &emn);
#endif
        stime = shr * 60 + smn;
        etime = ehr * 60 + emn;

    	if (ntime >= stime && ntime <= etime) 
        {
            if (days == EVERYDAY) 
            {
                insche = 1;
                break;
            } 
            else if (days == WORKDAY)
            {
                if (check->tm_wday <= FRI || check->tm_wday >= MON)
                {
                    insche = 1;
                    break;
                }
            }
            else if (days == check->tm_wday+1)
            {
                insche = 1;
                break;
            }
        }
    }
	//Suzhou update for mend schedule check solution
    fclose(fp);
    if (insche 
#ifdef _SC_SCHEDULE_NULL_IS_ALL_
        || 0 == num_sch
#endif
        )
    {
        return 1;
    }
    else
    {
        return 0;
    }
}
//Suzhou update,For mending event schedeule check solution
int event_chk_sch(EVENT_SCH *event_sche)
{
    time_t now;
    struct tm *check;
    int ntime;
    int i = 0;
#ifdef _SC_SCHEDULE_NULL_IS_ALL_
    int sch_list_num =0;
#endif
    
    if (ALWAYS_ON == event_sche->enable)
    {
        return 1;
    }
    now = time(NULL);
    check = localtime(&now);
    ntime = check->tm_hour*60 + check->tm_min;
    for(i=0;i<10;i++)
    {
        if (event_sche->sch[i].day!=0)
        {
            if (ntime>= event_sche->sch[i].stime && 
                ntime <= event_sche->sch[i].etime && 
                (event_sche->sch[i].day&(1<<check->tm_wday))!=0)
            {
                return 1;
                break;
            }
#ifdef _SC_SCHEDULE_NULL_IS_ALL_
            sch_list_num ++;
#endif
        }
    }
#ifdef _SC_SCHEDULE_NULL_IS_ALL_
    if ( 0 == sch_list_num)
    {
        return 1;
    }
    else
#endif       
    {
        return 0;
    }
}

#if 0
int schedule_add(schd_t *schd)
{
    int i = 0;
    FILE *fp = NULL;
    char buffer[256];
    char *schedule = schd->s_string;

    fp = fopen(SYSTEM_CONF, "r+");
    if (fp == NULL) {
	return -1;
    }

    if(schd->s_type == SCHD_ALERT) {
	for(i=0; i < 10 ; i++) {
		char tmp[32];
		
		sprintf(tmp, EVENT_NAME_FORMAT, i+1);	

    		memset(buffer, 0, 256);
	
    		PRO_GetStr(SEC_EVENT, tmp, buffer, 256, fp);
		
		if(!strlen(buffer)) {
        		PRO_SetStr(SEC_EVENT, tmp, schedule, SYSTEM_CONF);
			schedule_enable(1);
			break;
		}
	}
    }
    else if(schd->s_type == SCHD_ACCESS) {
	for(i=0; i < 10 ; i++) {
		char tmp[32];
		
		sprintf(tmp, VIDEO_NAME_FORMAT, i+1);	

    		memset(buffer, 0, 256);
	
    		PRO_GetStr(SEC_VIDEO, tmp, buffer, 256, fp);
		
		if(!strlen(buffer)) {
        		PRO_SetStr(SEC_VIDEO, tmp, schedule, SYSTEM_CONF);
			break;
		}
	}
    }

    fclose(fp);

    return Event_OK;
}


int del_single_schedule(char *schedule, int type)
{
    FILE *fp = NULL;
    char buffer[256];
    int i = 0;
    unsigned int schedule_cnt=0;

    memset(buffer, 0, 256);

    fp = fopen(SYSTEM_CONF, "r+");
    if (fp == NULL) {
	return -1;
    }

    if(type == SCHD_ALERT) {
	for(i=0; i < 10 ; i++) {
		char tmp[32];
		
		sprintf(tmp, EVENT_NAME_FORMAT, i+1);	

    		memset(buffer, 0, 256);
	
    		PRO_GetStr(SEC_EVENT, tmp, buffer, 256, fp);
		if(strlen(buffer)!=0)
		{
			schedule_cnt++;
		}
		if (!memcmp(buffer, schedule, 9)) {
			schedule_cnt--;
        		PRO_SetStr(SEC_EVENT, tmp, "", SYSTEM_CONF);
			//break;
		}
	}
	if(schedule_cnt == 0)
		schedule_enable(0);
    }
    else if(type == SCHD_ACCESS) {
	for(i=0; i < 10 ; i++) {
		char tmp[32];
		
		sprintf(tmp, VIDEO_NAME_FORMAT, i+1);	

    		memset(buffer, 0, 256);
	
    		PRO_GetStr(SEC_VIDEO, tmp, buffer, 256, fp);
		
		if (!memcmp(buffer, schedule, 9)) {
        		PRO_SetStr(SEC_VIDEO, tmp, "", SYSTEM_CONF);
			break;
		}
	}
    }

    fclose(fp);

    return Event_OK;
}

#ifdef _SC_SCHEDULE_SAVEALL_SOLUTION_
int schedule_save_all(schd_t *schd)
{
	int ret;

	if (NULL == schd || NULL == schd->s_string)
	{
		return -1;
	}

	switch (schd->s_type)
	{
		case SCHD_ALERT:
		{
		   ret = PRO_SetStr(SEC_EVENT, EVENT_DEF1, schd->s_string, SYSTEM_CONF);
			if (ret)
			{
				return -1;
			}
			break;
		case SCHD_ACCESS:
		{
		   ret = PRO_SetStr(SEC_VIDEO, VIDEO_SCH, schd->s_string, SYSTEM_CONF);
			if (ret)
			{
				return -1;
			}
			break;
		}
		case SCHD_NVSION:
		{
			// Add
			break;
		}
		default:
			break;
	}
	return 0;
}

#endif

int schedule_del(schd_t *schd)
{
    char buff[16];
#ifndef _SC_SCHEDULE_CAN_MODIFY_	
    int shr, smn, ehr, emn, weekday = 0;
    char *schedule = schd->s_string;
#endif	

    memset(buff, 0, 16);

#ifdef _SC_SCHEDULE_CAN_MODIFY_
	del_single_schedule(schd->s_string, (int)schd->s_type);
#else
    /* reformat schedule argument into several 10-bytes configuration file format */
    if (*schedule==SEPERATOR)
    	schedule++;	
    while (*schedule != '\0') {
	if (!strncmp(schedule, "Eve", 3))
        {
		sscanf(schedule, "%s %*s %d:%d - %d:%d", buff, &shr, &smn,
			&ehr, &emn);
		weekday = 9;
	}
	else
	{
		sscanf(schedule, "%s,%d:%d,%d:%d", buff, &shr, &smn, &ehr,
			&emn);
		if (!strncmp(buff, "Wee", 3))
			weekday = 8;
		if (!strncmp(buff, "Sun", 3))
			weekday = 1;
		if (!strncmp(buff, "Mon", 3))
			weekday = 2;
		if (!strncmp(buff, "Tue", 3))
			weekday = 3;
		if (!strncmp(buff, "Wed", 3))
			weekday = 4;
		if (!strncmp(buff, "Thu", 3))
			weekday = 5;
		if (!strncmp(buff, "Fri", 3))
			weekday = 6;
		if (!strncmp(buff, "Sat", 3))
			weekday = 7;
	}
	
	sprintf(buff, "%d%02d%02d%02d%02d", weekday, shr, smn, ehr,
		emn);
	del_single_schedule(buff, (int)schd->s_type);

	while (*schedule != '\0' && *schedule != SEPERATOR)
	    schedule++;
	if (*schedule != '\0')
	    schedule ++; // 0x0d 0x0a
    }
#endif

    return Event_OK;
}

int del_event_schedule(char *schedule)
{
    FILE *fp = NULL;
    char buffer[256];
    char tmp[256];
    char buff[16];
    int i = 0;
    int j = 0;

    memset(buff, 0, 16);
    memset(buffer, 0, 256);
    memset(tmp, 0, 256);

    fp = fopen(SYSTEM_CONF, "r+");
    if (fp == NULL) {
	return -1;
    }

    PRO_GetStr("event", "event_schedule", buffer, 256, fp);

    fclose(fp);

    {
	char week[16];
	int shr, smn, ehr, emn, weekday = 0;

	if (strstr(schedule, "Every") != NULL)
	    sscanf(schedule, "%s %*s %d:%d - %d:%d", week, &shr, &smn,
		   &ehr, &emn);
	else
	    sscanf(schedule, "%s %d:%d - %d:%d", week, &shr, &smn, &ehr,
		   &emn);
	if (memcmp(week, "Eve", 3) == 0)
	    weekday = 9;
	if (memcmp(week, "Wee", 3) == 0)
	    weekday = 8;
	if (memcmp(week, "Sun", 3) == 0)
	    weekday = 1;
	if (memcmp(week, "Mon", 3) == 0)
	    weekday = 2;
	if (memcmp(week, "Tue", 3) == 0)
	    weekday = 3;
	if (memcmp(week, "Wed", 3) == 0)
	    weekday = 4;
	if (memcmp(week, "Thu", 3) == 0)
	    weekday = 5;
	if (memcmp(week, "Fri", 3) == 0)
	    weekday = 6;
	if (memcmp(week, "Sat", 3) == 0)
	    weekday = 7;

	sprintf(schedule, "%d%02d%02d%02d%02d", weekday, shr, smn, ehr,
		emn);

//      Errorlog(schedule);
    }

    /* TODO: multiple schedule */

    while (buffer[i] != '\0') {

	if (memcmp(&buffer[i], schedule, 9) != 0) {

	    memcpy(&tmp[j], &buffer[i], 10);
	    j = j + 10;
	    //sprintf(Errlog,"tmp=%s\n",tmp);
	    //Errorlog(Errlog);
	}

	while (buffer[i] != '\0' && buffer[i] != ':')
	    i++;
	if (buffer[i] != '\0')
	    i++;
    }


    PRO_SetStr("event", "event_schedule", tmp, SYSTEM_CONF);

    return Event_OK;
}
#endif

