/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#include "conf_sec.h"
#include "ntp_config.h"
#include "ntp_global.h"
//#include "fntp.h"
static char buff[256];


static int check_ntp_name(char *p){
#if 0
	// Range : All graphic characters
	while((*p) !='\0'){
		if((*p >= 0x21 && *p <= 0x7E) && (*p != 0x22))
			 	p++;
		else
			return NTP_ERROR;
	 }
#else
	// Range :A-Z ,a-z, 0-9 , _ , . , -
	while((*p) !='\0'){
		if( (*p >= 0x41 && *p <= 0x5a) || (*p >= 0x61 && *p <=0x7a) || (*p >= 0x30 && *p <= 0x39) || (*p == 0x5f) || (*p == 0x2e) || (*p==0x2d) ){
			 	p++;
		}
		else{
			return NTP_ERROR;
		}
	}
#endif
	 return NTP_OK;

}

int NTPReadData(NTP_INFO *ntpinfo){
	FILE *fd;
	int ret;

	fd = fopen(SYSTEM_CONF,"rt");
	if(fd==NULL){
		return NTP_ERROR;
        }

	ret = PRO_GetInt(SEC_SYS, SYS_NTP_MODE, &ntpinfo->status ,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	ret = PRO_GetStr(SEC_SYS, SYS_NTP_SERVER, ntpinfo->server, NTP_ADDR_LEN+1 ,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	ret = PRO_GetInt(SEC_SYS, SYS_NTP_DATE, &ntpinfo->weekday ,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	ret = PRO_GetInt(SEC_SYS, SYS_NTP_HOUR, &ntpinfo->hour ,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	ret = PRO_GetInt(SEC_SYS, SYS_NTP_MIN, &ntpinfo->min ,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	fclose(fd);
	return NTP_OK;

}

int NTPWriteData(NTP_INFO *ntpinfo){	
	int ret;

#ifdef _USER_SETNTP_
	SchdInfo_t schinfo={ {NTP_SETCRON},
			 {SCHD_DONTCARE, SCHD_DONTCARE, SCHD_DONTCARE},
			 {SCHD_DONTCARE, SCHD_DONTCARE, SCHD_DONTCARE},
			 {SCHD_DONTCARE, SCHD_DONTCARE, SCHD_DONTCARE},
			 {SCHD_DONTCARE, SCHD_DONTCARE, SCHD_DONTCARE},
			 {SCHD_DONTCARE, SCHD_DONTCARE, SCHD_DONTCARE},
			};

	if(!(ntpinfo->status)){
		ret=SCHDDelScheduleByCmd(&schinfo);	

		if (ret != NTP_OK){
			return NTP_ERROR;
		}

		ret = PRO_SetInt(SEC_SYS, SYS_NTP_MODE, ntpinfo->status, SYSTEM_CONF);		

		if (ret != NTP_OK) { 
		       return NTP_ERROR;
		}

		return NTP_OK;
	}
#endif

#if 0
	if((strlen(ntpinfo->server) == 0) || (!strcmp(ntpinfo->server,STR_NULL_IP)))		
		return NTP_ERROR;
#endif
	
	ret=check_ntp_name(ntpinfo->server);
	if( ret ==NTP_ERROR ){
		return NTP_ERROR;
	}
	
	if((ntpinfo->weekday > 7) || (ntpinfo->weekday < -1))
		return NTP_ERROR;
        

	if((ntpinfo->hour > 23) || (ntpinfo->hour < 0))
		return NTP_ERROR;

	if((ntpinfo->min > 59) || (ntpinfo->min < 0))
		return NTP_ERROR;

	ret = PRO_SetInt(SEC_SYS, SYS_NTP_MODE, ntpinfo->status, SYSTEM_CONF);		

	if (ret != NTP_OK) {
                return NTP_ERROR;
	}

	ret = PRO_SetStr(SEC_SYS, SYS_NTP_SERVER, ntpinfo->server, SYSTEM_CONF);		

	if (ret != NTP_OK) {
                return NTP_ERROR;
	}

#ifdef _USER_SETNTP_
	ret = PRO_SetInt(SEC_SYS, SYS_NTP_DATE, ntpinfo->weekday, SYSTEM_CONF);		

	if (ret != NTP_OK) {
                return NTP_ERROR;
	}

	ret = PRO_SetInt(SEC_SYS, SYS_NTP_HOUR, ntpinfo->hour, SYSTEM_CONF);		
	if (ret != NTP_OK) {
                return NTP_ERROR;
	}

	ret = PRO_SetInt(SEC_SYS, SYS_NTP_MIN, ntpinfo->min, SYSTEM_CONF);		

	if (ret != NTP_OK) {
                return NTP_ERROR;
	}

	ret=SCHDDelScheduleByCmd(&schinfo);
	
	if (ret != NTP_OK){
			return NTP_ERROR;
	}

	if(ntpinfo->weekday != -1 && (ntpinfo->status == 1)){

		schinfo.hour.start=ntpinfo->hour;

		schinfo.min.start=ntpinfo->min;

		if(ntpinfo->weekday == 0)  
			;
		else if (ntpinfo->weekday == 7)
			schinfo.week.start=0;
		else
			schinfo.week.start=ntpinfo->weekday;

		ret=SCHDAddSchedule(&schinfo);
	
		if(ret != NTP_OK){
			return NTP_ERROR;
		}

	}
#endif
	return NTP_OK;

}

int SetNTP(void){
 	char server[NTP_ADDR_LEN+1];
	FILE *fd;
	int ret;
	
	fd = fopen(SYSTEM_CONF,"rt");
	if(fd==NULL){
		return NTP_ERROR;
        }

	ret = PRO_GetStr(SEC_SYS, SYS_NTP_SERVER, server, NTP_ADDR_LEN+1,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	fclose(fd);
	
	memset(buff,'\0',sizeof(buff));
	sprintf(buff,"%s %s & > /dev/null 2> /dev/null",EXEC_NTP_BINARY,server);
	ret=(system(buff)/256);
	
	if(ret!= 0){	
	   return NTP_ERROR;
	}  

	return NTP_OK;
}

int ReadDayLightSaving(int* daysaving){
	FILE *fd;
	int ret;

	fd = fopen(SYSTEM_CONF,"rt");
	if(fd==NULL){
		return NTP_ERROR;
        }

	ret = PRO_GetInt(SEC_SYS, SYS_DAY_SAVING, daysaving ,fd);	
	if (ret != NTP_OK) {
		fclose(fd);
		return NTP_ERROR;
	}

	fclose(fd);

	return NTP_OK;	
}


int WriteDayLightSaving(int daysaving){
	int ret;
	

	ret = PRO_SetInt(SEC_SYS, SYS_DAY_SAVING, daysaving, SYSTEM_CONF);		

	if (ret != NTP_OK) {
                return NTP_ERROR;
	}

	return NTP_OK;	
}
