
/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <unistd.h> // usleep
#include "PRO_file.h"
#include "ddns_conf.h"


//----------------------------------------------
// nbuf - buffer to save hwid
// len - length of buffer
//----------------------------------------------
int MAC_encode(unsigned char *nbuf,int len)
{
	
	unsigned char eth_addr[6]={0x00,0xc0,0x02,0x00,0x00,0x00};
	int sockd,i,no;
	struct ifreq ifr;

	sockd = socket(AF_INET, SOCK_STREAM, 0); /* IP = 0 */	

	if (sockd == -1) {
		goto tx;
	}

	strcpy(ifr.ifr_name, "eth0");

	if (ioctl(sockd,SIOCGIFHWADDR,&ifr) == 0) {
		for(i=0;i<6;i++) 
			eth_addr[i] =(unsigned char)ifr.ifr_hwaddr.sa_data[i];
	}
	
	close(sockd);
tx:
	/* conver mac address to 16 byte unsigned char */
	/*  0  0: C  0: 0  2: 1  2: 3  4: 5  6             */  
	/* 00|00|63|00|00|32|31|32|33|34|35|36|00|00|00... */
        memset(nbuf,0,len);
        if(len>12)
	   no=6;
	else
	   no=(len/2);
	for (i = 0; i < no; i++) {
	        sprintf(nbuf,"%02x", eth_addr[i]);
		nbuf=nbuf+2;
	}

	return 0;
}
//-----------------------------------------------------
// purpose: translate string to hex 
// input:
// keys - id in string format
// size - size of id
// output: id - buffer to save hex format 
// MAX size of id is 80 bytes
//-----------------------------------------------------
void TxStrToHex(char *keys,unsigned char *id,int size)
{
   unsigned char key[81];
   int k,temp;
   char *p;

   if(keys[0]==0){
	memset(id,0,size);
	return;
   }
   p = &keys[0];	/* init data */
   k = 0;		/* init data */
   while (p != (char *) NULL && p<(keys+size*2)) {
	if (sscanf(p, "%2x", &temp) != 1) {
		break;
	}
	key[k++] = (unsigned char) (temp & 0xFF);
		p += 2;
   } /* end-while: translate STRING to HEX */
   memcpy(id,  &key[0], size);
}

int DDNS_GetConf(DDNS_Conf *v)
{
   FILE *f;
   //char keys[Str128BitLen],
   char tmp[80];
   int i;

   //Set default value
   memset(v,0,sizeof(DDNS_Conf));
   v->auth_st=-1;		//default is n/a
   v->update_st=-1;		//default is n/a
   v->schedule=DDNS_UNIT_HR;
   v->interval=4;
   v->start_hour=12;	
#ifdef _SC_TWO_DDNS_ALL_EXIST_
	v->enable=1;
#endif
   f = fopen(SYSTEM_CONF,"rt");
   if (f == NULL)
      return DDNS_ERROR;
   PRO_GetStr(SEC_SOLO,SOLO_DEVICE,v->device,DeviceLen,f);
   PRO_GetStr(SEC_SYS,SYS_HOSTNAME,v->def_device,DeviceLen,f);
   for(i=0;i<strlen(v->def_device);i++){
	if (v->def_device[i]==' ' || v->def_device[i]=='_')
	   v->def_device[i]='-';
 	if (v->def_device[i]>='A' && v->def_device[i]<='Z')
	   v->def_device[i]|=0x20;

   }
  
#ifdef _SC_TWO_DDNS_ALL_EXIST_
   PRO_GetInt(SEC_SOLO,SOLO_MODE,&v->enable,f);
#endif
   PRO_GetStr(SEC_SOLO,SOLO_USER,v->user,DDNSUserLen,f);
   PRO_GetStr(SEC_SOLO,SOLO_PW,v->pw,DDNSPWLen,f);
   PRO_GetStr(SEC_SOLO,SOLO_DOMAIN,v->domain,DDNSDomainLen,f);
   PRO_GetInt(SEC_HTTP,HTTP_PORT2_NUM,&v->port,f);
   if(v->port<1024 || v->port>65535 ) v->port=1024;

   //PRO_GetStr(SEC_SOLO,SOLO_HWID,v->hwid,13,f);
   //create hwid from mac address
   MAC_encode(v->hwid,sizeof(v->hwid));

   memset(v->keyid,0,sizeof(v->keyid));
   PRO_GetStr(SEC_SOLO,SOLO_KEYID,v->keyid,Str128BitLen,f);

   memset(v->rand_sec,0,sizeof(v->rand_sec));
   PRO_GetStr(SEC_SOLO,SOLO_RAND_SEC,v->rand_sec,Str128BitLen,f);

   memset(tmp,0,sizeof(tmp));
   PRO_GetStr(SEC_SOLO,SOLO_LAST_OK,tmp,sizeof(tmp),f);
   v->last_ok=(unsigned long)atol(tmp);
   memset(tmp,0,sizeof(tmp));
   PRO_GetStr(SEC_SOLO,SOLO_LAST_TRY,tmp,sizeof(tmp),f);
   v->last_try=(unsigned long)atol(tmp);
   PRO_GetInt(SEC_SOLO,SOLO_AUTH_STATUS,&v->auth_st,f);
   PRO_GetInt(SEC_SOLO,SOLO_UPDATE_STATUS,&v->update_st,f);
   PRO_GetInt(SEC_SOLO,SOLO_SCHEDULE,&v->schedule,f);
   PRO_GetInt(SEC_SOLO,SOLO_INTERVAL,&v->interval,f);
   PRO_GetInt(SEC_SOLO,SOLO_HOUR,&v->start_hour,f);
   PRO_GetInt(SEC_SOLO,SOLO_MIN,&v->start_min,f);
   PRO_GetInt(SEC_HTTP,HTTP_PORT2,&v->web_enable,f);
   fclose(f);
   return 0;
}
//--------------------------------------------------------
// purpose: translate hex data to string
// input: id - hex format data
//        length - size of id
// output: keys - buffer to save string fromat data
//--------------------------------------------------------
// NOTE: !!!! SIZOF keys MUST >=length*2+1 !!!
//--------------------------------------------------------
void TxHexToStr(unsigned char *id,char *keys,int length)
{
   int  i;
   char key[Str128BitLen];

   memset(keys,0,length*2+1);
   memcpy(&key[0], id, length);
   sprintf(&keys[0], "%.2x", key[0]);
   for(i=1; i<length; i++) {
	sprintf(&keys[0], "%s%.2x", &keys[0], key[i]);
   }
}
void lowerstr(char *s)
{
   int i;
   for(i=0;i<strlen(s);i++){
	if(s[i]>='A' && s[i]<='Z')
	   s[i]|=0x20;
   }
}
int DDNS_SetConf(DDNS_Conf *v)
{
   FILE *fp;

   fp = PRO_uopen(SYSTEM_CONF);
   if (fp == NULL)
      return -1;
   lowerstr(v->user);
   lowerstr(v->domain);
   lowerstr(v->device);
   // if the section exists, keep the section name; else create one
   PRO_u2sect(SEC_SOLO,PRO_WRSEC);
   // update the attributes
#ifdef _SC_TWO_DDNS_ALL_EXIST_
   fprintf(fp,"%s=%d\n",SOLO_MODE,v->enable);
#endif
   fprintf(fp,"%s=%s\n",SOLO_USER,v->user);
   fprintf(fp,"%s=%s\n",SOLO_PW,v->pw);
   fprintf(fp,"%s=%s\n",SOLO_DOMAIN,v->domain);
   fprintf(fp,"%s=%s\n",SOLO_DEVICE,v->device);

   fprintf(fp,"%s=%s\n",SOLO_HWID,v->hwid);

   
   fprintf(fp,"%s=%s\n",SOLO_KEYID,v->keyid);

   fprintf(fp,"%s=%s\n",SOLO_RAND_SEC,v->rand_sec);

   if(v->keyid[0]==0){
	v->last_ok=0;
	v->last_try=0;
	v->auth_st=-1;
	v->update_st=-1;
   }
   fprintf(fp,"%s=%lu\n",SOLO_LAST_OK,v->last_ok);
   fprintf(fp,"%s=%lu\n",SOLO_LAST_TRY,v->last_try);
   fprintf(fp,"%s=%d\n",SOLO_AUTH_STATUS,v->auth_st);
   fprintf(fp,"%s=%d\n",SOLO_UPDATE_STATUS,v->update_st);

   fprintf(fp,"%s=%d\n",SOLO_SCHEDULE,v->schedule);
   fprintf(fp,"%s=%d\n",SOLO_INTERVAL,v->interval);
   fprintf(fp,"%s=%d\n",SOLO_HOUR,v->start_hour);
   fprintf(fp,"%s=%d\n",SOLO_MIN,v->start_min);
   // give up original section info
   PRO_uclose(SYSTEM_CONF,666,PRO_GOWRIRST);

   PRO_SetInt(SEC_HTTP,HTTP_PORT2_NUM,v->port,SYSTEM_CONF);
   PRO_SetInt(SEC_HTTP,HTTP_PORT2,v->web_enable,SYSTEM_CONF);
   return 0;
}

#ifdef _SC_SUPP_ISP_DDNS_AS_SOLOLINK_
#define DDNS_STR	"ddns"
int DDNS_Get_ISP_ddns_url(char *isp_ddns_url)
{
   FILE *f;

   if(	NULL==isp_ddns_url)
   {
	return DDNS_ERROR;
   }
     f = fopen(SYSTEM_CONF,"rt");
   if (f == NULL)
      return DDNS_ERROR;
   PRO_GetStr(DDNS_STR, LCS_ISP_DDNS_URL, isp_ddns_url, LCS_ISP_DDNS_URL_LEN, f);
	isp_ddns_url[LCS_ISP_DDNS_URL_LEN-1]=0;

     fclose(f);
   return 0;
   
}
#endif

