
/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/
#ifndef  _DDNS_CONFIG_H_
#define  _DDNS_CONFIG_H_

#include "sc_config.h"
#include "conf_sec.h"

#define  DDNS_OK	0 
#define  DDNS_ERROR  	-1

#ifdef _SC_SUPP_ISP_DDNS_AS_SOLOLINK_
#define LCS_ISP_DDNS_URL	"lcs_isp_ddns_url"
#define LCS_ISP_DDNS_URL_LEN	(64+1)
#endif
#ifdef _SC_INTAMAC_DDNS_
#define DDNS_PARSER_URL	"int_ddns_chk_url"
#define DDNS_PARSER_URL_LEN 	256
#endif

#define		DDNSUserLen	41
#define		DDNSPWLen	21
#define		DDNSDomainLen	201
#define		DeviceLen	21
#define		Str128BitLen	33	//(2*16+1)
#define		HWIDLen		12

#define DDNS_UNIT_MIN 	1
#define DDNS_UNIT_HR	2
#define DDNS_UNIT_DAY	3

typedef struct DDNS_Conf {
#ifdef _SC_TWO_DDNS_ALL_EXIST_
	int enable;
#endif
	char	user[DDNSUserLen];
	char 	pw[DDNSPWLen];
	char 	domain[DDNSDomainLen];
	char	device[DeviceLen];	
	char	def_device[DeviceLen];	//build from camera name
	int	port;
	unsigned char hwid[HWIDLen+1];
	unsigned char rand_sec[Str128BitLen];
	char keyid[Str128BitLen];
	unsigned long last_ok;
	unsigned long last_try;
	int	auth_st;	//0: ok 1: failed, -1: n/a
	int	update_st;	//0: ok 1: failed, -1: n/a
  	int schedule; 		//scheduling unit
	int interval;		//scheduling interval
	int start_hour;
	int start_min;
	int web_enable;
} DDNS_Conf;

#ifdef _SC_SUPP_ISP_DDNS_AS_SOLOLINK_
int DDNS_Get_ISP_ddns_url(char *isp_ddns_url);
#endif
int DDNS_GetConf(DDNS_Conf *conf);
int DDNS_SetConf(DDNS_Conf *conf);
void TxStrToHex(char *keys,unsigned char *id,int size);
void TxHexToStr(unsigned char *id,char *keys,int length);
void lowerstr(char *s);

#endif
