
/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <unistd.h>
#include "ddns_lock.h"


//---------------------------------------------------------------------------
// purpose: check file lock status
// return: ST_UNLOCKED (0) - file is unlocked
//         ST_LOCKED   (1) - file is locked
//         ST_UNKNOWN (-1) - file is locked by unknown process, caller 
//                              should check again
//---------------------------------------------------------------------------
int check_filelock(char *fname)
{
   int fd;
   pid_t pid=-1;

   fd=open(fname,O_WRONLY | O_CREAT | O_EXCL,00644);
   if(fd<0 && errno==EEXIST){
        fd=open(fname,O_RDONLY,0644);
        if(fd>0){
           read(fd,&pid,sizeof(pid));
           if (kill(pid,0)){
		//process not exist
		close(fd); 
	        unlink(fname);
		return(0);
           }
	   close(fd);
        }  
        else{
	   unlink(fname);
	   return(0);
        }
	//the file is already locked
         
	return(-1);
   }
   else if (fd < 0) {
	//unknown error
	return(-1);
   }
   return(fd);
}
