/*
 *             SerComm CORPORATION PROPRIETARY INFORMATION         
 *                                                                    	
 *     This software is supplied under the terms of a license agree-   	
 *     ment or non-disclosure agreement with SerComm Corporation         
 *     and may not be copied nor disclosed except in accordance       
 *     with the terms of that agreement.                              
 *                                                                   
 */

#ifndef __SC_DEBUG_H__
#define __SC_DEBUG_H__

#include "sc_config.h"

/* Global Macro defines*/
//#define _SC_DBG_ON_ALL_

// The switch for the function models...
#ifdef _SC_DBG_ON_ALL_
#define _SC_DBG_ON_CGI_
#define _SC_DBG_ON_WEB_
#define _SC_DBG_ON_UPNPIGD_
#define _SC_DBG_ON_DDNS_
//#define _SC_DBG_ON_UPGRADE_
#define _SC_DBG_ON_IO_
#define _SC_DBG_ON_DNSWITCH_
#define _SC_DBG_ON_QOS_
#define _SC_DBG_ON_IPUPDATE_
#define _SC_DBG_ON_TRIG_
#define _SC_DBG_ON_DSPDAE_
#define _SC_DBG_ON_DHCPC_
#define _SC_DBG_ON_AUDIO_UP_
#endif
/* Global Macro defines end */

#ifdef _SC_DBG_ON_ALL_
	 int sc_pkt(const char *format, ...);
	 int sc_printf(char *filename, const char *format, ...);
#else /* NULL debug main functions define */
	 #define sc_pkt(...)
	 #define sc_printf(...)
#endif

/* Function API Macro defines */

#define SC_DBG_FILENAME			"/tmp/sc_tmp.txt"
#define SC_DBG(x, args...)		sc_printf(SC_DBG_FILENAME,x,## args)
#define SC_LOG(x, args...)		sc_printf(SC_DBG_FILENAME,x,## args)
#define SC_ERR(x, args...)		sc_printf(SC_DBG_FILENAME,x,## args)
#define SC_LINE					sc_printf(SC_DBG_FILENAME, "%s(%d)\n", __FUNCTION__, __LINE__)

#ifdef _SC_DBG_ON_CGI_
#define SC_DBG_CGI_FILENAME	"/tmp/sc_cgi.txt"
#define SC_DBG_CGI(x, args...)			sc_printf(SC_DBG_CGI_FILENAME,x,## args)
//#define SC_DBG_CGI							sc_pkt
#else
#define SC_DBG_CGI(...)
#endif

#ifdef _SC_DBG_ON_WEB_
#define SC_DBG_WEB_FILENAME	"/tmp/sc_web.txt"
#define SC_DBG_WEB(x, args...)				sc_printf(SC_DBG_WEB_FILENAME,x,## args)
//#define SC_DBG_WEB							sc_pkt
#else
#define SC_DBG_WEB(...)
#endif

#ifdef _SC_DBG_ON_UPNPIGD_
#define SC_DBG_UPNPIGD_FILENAME	"/tmp/sc_upnpigd.txt"
#define SC_DBG_UPNPIGD(x, args...)				sc_printf(SC_DBG_UPNPIGD_FILENAME,x,## args)
//#define SC_DBG_UPNPIGD							sc_pkt
#else
#define SC_DBG_UPNPIGD(x...)		
#endif
#define SC_LOG_UPNPIGD		SC_DBG_UPNPIGD
#define SC_ERR_UPNPIGD		SC_DBG_UPNPIGD


#ifdef _SC_DBG_ON_DDNS_
#define SC_DBG_DDNS_FILENAME	"/tmp/sc_ddns.txt"
#define SC_DBG_DDNS(x,args...)					sc_printf(SC_DBG_DDNS_FILENAME,x,## args)			
//#define SC_DBG_DDNS							sc_pkt
#define SC_ERR_DDNS(x...)	SC_DBG_DDNS	
#else
#define SC_DBG_DDNS(x...)		
#define SC_ERR_DDNS(x...)		
#endif

#ifdef _SC_DBG_ON_UPGRADE_
#define SC_DBG_UPGRADE_FILENAME	"/tmp/sc_upgrade.txt"
#define SC_DBG_UPGRADE(x,args...)					sc_printf(SC_DBG_UPGRADE_FILENAME,x,## args)			
//#define SC_DBG_UPGRADE							sc_pkt
#define SC_ERR_UPGRADE(x...)	SC_DBG_UPGRADE	
#else
#define SC_DBG_UPGRADE(x...)		
#define SC_ERR_UPGRADE(x...)		
#endif

#ifdef _SC_DBG_ON_IO_
#define SC_DBG_IO_FILENAME	"/tmp/sc_io.txt"
#define SC_DBG_IO(x,args...)					sc_printf(SC_DBG_IO_FILENAME,x,## args)			
//#define SC_DBG_IO							sc_pkt
#define SC_ERR_IO(x...)	SC_DBG_IO	
#else
#define SC_DBG_IO(x...)		
#define SC_ERR_IO(x...)		
#endif

#ifdef _SC_DBG_ON_DNSWITCH_
#define SC_DBG_DNSWITCH_FILENAME	"/tmp/sc_dnswitch.txt"
#define SC_DBG_DNSWITCH(x,args...)					sc_printf(SC_DBG_DNSWITCH_FILENAME,x,## args)			
//#define SC_DBG_DNSWITCH							sc_pkt
#else
#define SC_DBG_DNSWITCH(x...)		
#endif

#ifdef _SC_DBG_ON_QOS_
#define SC_DBG_QOS_FILENAME	"/tmp/sc_qos.txt"
#define SC_DBG_QOS(x,args...)					sc_printf(SC_DBG_QOS_FILENAME,x,## args)			
//#define SC_DBG_QOS							sc_pkt
#else
#define SC_DBG_QOS(x...)		
#endif

#ifdef _SC_DBG_ON_IPUPDATE_
#define SC_DBG_IPUPDATE_FILENAME	"/tmp/sc_ipupdate.txt"
#define SC_DBG_IPUPDATE(x,args...)					sc_printf(SC_DBG_IPUPDATE_FILENAME,x,## args)			
//#define SC_DBG_IPUPDATE							sc_pkt
#else
#define SC_DBG_IPUPDATE(x...)		
#endif

#ifdef _SC_DBG_ON_TRIG_
#define SC_DBG_TRIG_FILENAME	"/tmp/sc_trig.txt"
#define SC_DBG_TRIG(x,args...)					sc_printf(SC_DBG_TRIG_FILENAME,x,## args)			
//#define SC_DBG_TRIG							sc_pkt
#else
#define SC_DBG_TRIG(x...)		
#endif

#ifdef _SC_DBG_ON_DSPDAE_
#define SC_DBG_DSPDAE_FILENAME	"/tmp/sc_dspdae.txt"
#define SC_DBG_DSPDAE(x,args...)					sc_printf(SC_DBG_DSPDAE_FILENAME,x,## args)			
//#define SC_DBG_DSPDAE							sc_pkt
#else
#define SC_DBG_DSPDAE(x...)		
#endif

#ifdef _SC_DBG_ON_DHCPC_
#define SC_DBG_DHCPC_FILENAME	"/tmp/sc_dhcpc.txt"
#define SC_DBG_DHCPC(x,args...)					sc_printf(SC_DBG_DHCPC_FILENAME,x,## args)			
//#define SC_DBG_DHCPC							sc_pkt
#else
#define SC_DBG_DHCPC(x...)		
#endif

#ifdef _SC_DBG_ON_AUDIO_UP_
#define SC_DBG_AUDIO_UP_FILENAME	"/tmp/sc_auup.txt"
#define SC_DBG_AUDIO_UP(x,args...)					sc_printf(SC_DBG_AUDIO_UP_FILENAME,x,## args)			
//#define SC_DBG_AUDIO_UP							sc_pkt
#else
#define SC_DBG_AUDIO_UP(x...) 		
#endif
#endif

