/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2006.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/

#ifndef __SC_TOOL_C__
#define __SC_TOOL_C__

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>

#include "sc_tool.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>

int tx_quot(char *buf,char *s,int blen)
{
   int i,j,len;

   memset(buf,0,blen);
   len=strlen(s);
   for(i=0,j=0;i<len;i++){
        if(s[i]!='"')
           buf[j++]=s[i];
        else{
           strcat(buf,"&quot;");
           j+=6;
        }
   }
   return(0);
}

static int GetAppsPidIn(char *name, char *spec_file)
{
#define SC_TMP_FILENAME_LEN			80	
	char tmp[SC_TMP_FILENAME_LEN+1];
	char pidfile[SC_TMP_FILENAME_LEN+1];
	FILE *fh;
	char *pstr;
	char *token=" \r\n";
	int find=0,p=0;

	if (spec_file)
	{
		strncpy(pidfile, spec_file, SC_TMP_FILENAME_LEN);
	}
	else
	{
		snprintf(pidfile, SC_TMP_FILENAME_LEN, "/tmp/%s%ld", name, time(NULL));
		snprintf(tmp, SC_TMP_FILENAME_LEN, "/bin/pidof %s > %s 2>/dev/null", name, pidfile);
		//printf("tmp=%s\n", tmp);
		system(tmp);
	}
	fh=fopen(pidfile, "r");
	if(!fh)
	{
		//SC_LINE;
		return(0);
	}
	while (fgets(tmp,sizeof(tmp),fh)!=0)
	{
		pstr=strtok(tmp,token);
		if(pstr)
		{
			find=1;
			p=atoi(tmp);
			break;
		}
	}
	fclose(fh);

	if (NULL == spec_file)
	{
		remove(pidfile);
	}
	if(!find)
	{
		//SC_LINE;
		return(0);
	}
	else
	{
		return(p);
	}
}

int GetAppsPid(char *name)
{
	return GetAppsPidIn(name, NULL);
}

/*
 *
 */
int SendSignal2Apps(char *app_name, int signal)
{
	int pid;
	//char buffer[256];

	if ((pid = GetAppsPid(app_name)))
	{
		return kill(pid, signal);
		/*
		sprintf(buffer, "/usr/bin/kill -%s %d >/dev/null 2>/dev/null ", signal, pid);
		if (dae_flag)
		{
			strcat(buffer, " & ");
		}
		system(buffer);
		*/
	}
	return 0;
}

int GetAppsPidBySpecFile(char *name, char *filename)
{
	return GetAppsPidIn(name, filename);
}

int SendSignal2AppsBySpecFile(char *name, int signal, char *filename)
{
	int pid;
	//char buffer[256];

	if ((pid = GetAppsPidBySpecFile(name, filename)))
	{
		return kill(pid, signal);
		/*
		sprintf(buffer, "/usr/bin/kill -%s %d >/dev/null 2>/dev/null ", signal, pid);
		if (dae_flag)
		{
			strcat(buffer, " & ");
		}
		system(buffer);
		*/
	}
	return 0;
}

#ifdef _SC_CHECK_PORT_USED_OR_NOT_
int CheckCanUsePort(int port,int proType)
{
    int sfd;
    int err = 1;
    struct sockaddr_in sockadr;

	if (STREAM_SOCKET_TYPE == proType)
	{
	    sfd = socket(PF_INET, SOCK_STREAM, 0);
	    if (-1 != sfd) 
	    {
	        memset(&sockadr, 0, sizeof(sockadr));
	        sockadr.sin_family		= AF_INET;
	        sockadr.sin_addr.s_addr	= htonl(INADDR_ANY);
	        sockadr.sin_port		= htons(port);
	        if (!bind(sfd, (struct sockaddr *)&sockadr, sizeof(sockadr)))
	        {
	            err = 0;
	        }
	        close(sfd);
	    }
	}
	else if (DGRAM_SOCKET_TYPE == proType)
	{
		err = 0;
	}
	return err;
}
#endif

/*
int main(int argc, char *argv[])
{
	printf("%d\n", GetAppsPid(argv[1]));
	return 0;
}
*/

#endif

