
/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2006.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/


#ifndef __CONF_SEC_H__
#define __CONF_SEC_H__

#include "sc_config.h"

#define DEF_CONF_FILE		            "/etc/def_sys.conf"
#define SYSTEM_CONF		                "/etc/system.conf"
#define SC_WIRELESS_INFO_FILENAME		"/proc/tiwlan/status"

#define SEC_SECURITY		"[security]"		// Must have the []
#define SECURITY_CHECKSUM		"checksum"

#define SEC_MAN  	 	    "Manufacture"
#define MAN_RELEASE_DATE	    "release_date"
#define MAN_DEF_NAME		    "def_name" 
#define MAN_DEF_IP		        "default_ip"
#define MAN_MAX_USER		    "max_user"
#define MAN_NTP_SUMMER_CHG      "summer_chg"

#ifdef _DDNS_SOLOLINK_
#define SEC_SOLO			"DDNS-SOLO"
#ifdef _SC_TWO_DDNS_ALL_EXIST_
#define SOLO_MODE		    	"sl_mode"
#endif
#define	SOLO_USER				"sl_user"
#define	SOLO_PW					"sl_pw"
#define	SOLO_DOMAIN				"sl_domain"
#define	SOLO_DEVICE				"sl_device"
#define	SOLO_SCHEDULE			"sl_schedule"
#define	SOLO_INTERVAL			"sl_interval"
#define	SOLO_HOUR				"sl_start_hour"
#define	SOLO_MIN				"sl_start_min"
#define SOLO_HWID		    	"sl_hwid"
#define SOLO_KEYID				"sl_keyid"
#define SOLO_RAND_SEC     		"sl_rand_sec"
#define SOLO_LAST_OK			"sl_last_ok"
#define SOLO_LAST_TRY     		"sl_last_try"
#define SOLO_AUTH_STATUS		"sl_auth_st"
#define SOLO_UPDATE_STATUS		"sl_update_st"
#endif

#define SEC_SYS			    "[SYSTEM]"		// Here must define with the '[ ]', because it will be used by upload CGI
#define SYS_CFG_VER		        "cfg_ver"
#define SYS_HOSTNAME		    "host_name"
#define SYS_COMMENT		        "comment"
#define SYS_TIME_FORMAT		    "time_format"
#define SYS_DATE_FORMAT		    "date_format"
#define SYS_TIME_ZONE		    "time_zone"
#define SYS_DAY_SAVING		    "daylight_saving"
#define SYS_NTP_MODE		    "ntp_mode"
#define SYS_NTP_SERVER		    "ntp_server"
#define SYS_NTP_DATE		    "ntp_date"
#define SYS_NTP_HOUR		    "ntp_hour"
#define SYS_NTP_MIN		        "ntp_min"
#define SYS_LED_MODE		    "led_mode"
#ifdef _SUPPORT_MULTI_LANGUAGE_
#define SYS_LANGUAGE_ID			"language_id"
#endif

#define SEC_LOG			    "LOG"
#define LOG_LOG_MODE		    "log_mode"
#define LOG_LOG_LEVEL			"log_level"
#define LOG_SYSLOG_MODE		    "syslog_mode"
#define LOG_SYSLOG_SERVER	    "syslog_server"
#define LOG_SYSLOG_PORT			"syslog_port"
#define LOG_IM_MODE				"im_mode"
#define	LOG_IM_SERVER			"im_server"
#define LOG_IM_ACCOUNT			"im_account"
#define LOG_IM_PASSWORD			"im_password"
#define LOG_IM_SENDTO			"im_sendto"
#define LOG_IM_MESSAGE			"im_message"
#define LOG_FTPLOG_MODE			"ftplog_mode"
#define LOG_SYSTEMLOG_MODE		"systemlog_mode"
#define LOG_SMTPLOG_MODE		"smtplog_mode"
#define LOG_IMLOG_MODE			"imlog_mode"

#define SEC_NETWORK		    "NETWORK"
#define NETWORK_IP_ADDR		    "ip_addr"
#define NETWORK_NETMASK		    "netmask"
#define NETWORK_GATEWAY		    "gateway"
#define NETWORK_DHCP		    "dhcp"
#define NETWORK_DNS_TYPE	    "dns_type"
#define NETWORK_DNS_SERVER	    "dns_server1"
#define NETWORK_DNS_SERVER2	    "dns_server2"
#define HTTP_NOTIFY	            "http_notify"
#define HTTP_URL	            "http_url"
#define HTTP_PROXY	            "http_proxy"
#define HTTP_PROXY_NO	        "http_proxy_no"
#define HTTP_METHOD	            "http_method"

#define SEC_WLAN		    "WIRELESS"
#define WLAN_TYPE		        "wlan_type"
#define WLAN_ESSID		        "wlan_essid"
#define WLAN_CHANNEL		    "wlan_channel"
#define WLAN_DOMAIN		        "wlan_domain"
#define WLAN_SECURITY		    "wlan_security"
#define WLAN_AUTH				"wep_authtype"	
#define WLAN_WEP_MODE		    "wep_mode"
#define WLAN_WEP_INDEX		    "wep_index"
#define WLAN_WEP_KEY1		    "wep_kep1"
#define WLAN_WEP_KEY2		    "wep_kep2"
#define WLAN_WEP_KEY3		    "wep_kep3"
#define WLAN_WEP_KEY4		    "wep_kep4"
#define WLAN_WEP_KEY		    "wep_ascii"
#define WLAN_WPA_KEY		    "wpa_ascii"
#define WLAN_WMM				"wmm"

#ifdef _WPA_WPA2_ENTERPRISE_
#define WLAN_WPA_AUTHTYPE		"WpaAuthType"
#define WLAN_TLSUSER			"Wpa_TLSUser"
#define WLAN_TLSKEYPASSWD       "Wpa_TLSPrivateKeyPasswd" 
#define	WLAN_TTLSAUTHTYPE		"Wpa_TTLSAuthType"
#define	WLAN_TTLSUSER			"Wpa_TTLSUser"
#define WLAN_TTLSPASSWD			"Wpa_TTLSPasswd"
#define WLAN_TTLSANONYNAME		"Wpa_TTLSAnnoyName"
#endif

#define	SEC_DDNS		    "DDNS"
#define DDNS_MODE		        "ddns_mode"
#define DDNS_SERVICE		    "ddns_service"
#define DDNS_ACCOUNT		    "ddns_account"
#define DDNS_PASSWORD		    "ddns_password"
#define DDNS_HOSTNAME		    "ddns_host_name"
#define DDNS_HOUR		        "ddns_hour"
#define DDNS_MINUTE		        "ddns_minute"
#define DDNS_UPDATE_UNIT	    "ddns_update_unit"
#define DDNS_UPDATE_PERIOD	    "ddns_update_period"


#define SEC_HTTP		    "HTTP"
#define	HTTP_PORT2		        "http_port2"		
#define	HTTP_PORT2_NUM		    "http_port2_num"
#ifdef _SC_HTTPS_SUPPORT_
#define	SSPORT_ENABLE			"ssport_enable"		
#define	SSPORT_NUMBER			"ssport_number"
#endif

#define SEC_RTSP_RTP		"RTSP_RTP"
#define RTSP_PORT		        "rtsp_port"
#define RTP_PORT		        "rtp_port"
#define RTP_SIZE		        "rtp_size"
#define MCAST_ENABLE			"mcast_enable"
#define MCAST_VIDEO_ADDR	    "mcast_video_addr"
#define MCAST_VIDEO_PORT	    "mcast_video_port"
#define MCAST_AUDIO_ADDR	    "mcast_audio_addr"
#define MCAST_AUDIO_PORT	    "mcast_audio_port"
#define	MCAST_HOPS		        "mcast_hops"

#define SEC_UPNP		    "UPNP"
#define UPNP_MODE		        "upnp_mode"
#define UPNP_TRAVERSAL		    "upnp_traversal"
#define UPNP_CAMERA		        "upnp_camera"

#define SEC_EMAIL		    "EMAIL"
#define EMAIL_SMTP_ENABLE		"smtp_enable"
#define EMAIL_SMTP_SERVER	    "smtp_server"
#define EMAIL_POP_SERVER	    "pop_server"
#define EMAIL_SMTP_PORT		    "smtp_port"
#define EMAIL_SMTP_AUTH		    "smtp_auth"
#define EMAIL_SMTP_ACCOUNT	    "smtp_account"
#define EMAIL_SMTP_PASSWORD	    "smtp_password"
#define EMAIL_SMTP2_ENABLE		"smtp2_enable"
#define EMAIL_SMTP2_SERVER		"smtp2_server"
#define EMAIL_POP2_SERVER		"pop2_server"
#define EMAIL_SMTP2_PORT		"smtp2_port"
#define EMAIL_SMTP2_AUTH		"smtp2_auth"
#define EMAIL_SMTP2_ACCOUNT		"smtp2_account"
#define EMAIL_SMTP2_PASSWORD	"smtp2_password"
#define	EMAIL_FROM_ADDR		    "from_addr"
#define	EMAIL_FROM_ADDR2		    "from_addr2"
#define EMAIL_TO_ADDR1		    "to_addr1"
#define EMAIL_TO_ADDR2		    "to_addr2"
#define EMAIL_TO_ADDR3		    "to_addr3"
#ifdef _SC_ALERT_MAIL_SWITCH_ATTCHMENT_
#define EMAIL_TO_ADDR4		    "to_addr4"
#define EMAIL_TOATT				"email_att"
#endif
#define EMAIL_SEND_EMAIL	    "send_email"
#define	EMAIL_SUBJECT		    "subject"
#ifdef _HAS_VIDEO_URL_FOR_SMTP_
#define	EMAIL_ENABLE_VIDEOURL	"enable_video_url"
#define	EMAIL_VIDEOURL			"video_url"
#endif

#define SEC_FTP			    "FTP"
#define FTP1			        "ftp1"
#define FTP1_SERVER		        "ftp1_server"
#define FTP1_ACCOUNT		    "ftp1_account"
#define FTP1_PASSWD		        "ftp1_passwd"
#define FTP1_PATH		        "ftp1_path"
#define FTP1_PASSIVE		    "ftp1_passive"
#define FTP1_PORT		        "ftp1_port"
#define FTP2			        "ftp2"
#define FTP2_SERVER		        "ftp2_server"
#define FTP2_ACCOUNT		    "ftp2_account"
#define FTP2_PASSWD		        "ftp2_passwd"
#define FTP2_PATH		        "ftp2_path"
#define FTP2_PASSIVE		    "ftp2_passive"
#define FTP2_PORT		        "ftp2_port"
#ifdef _SC_CAN_CHANGE_FTP_FILE_NAME_
#define FTP_FNAME               "ftp_fname"
#endif


#define VIDEO_NAME_FORMAT	    "video_define%d"
#define SEC_VIDEO		    "VIDEO"
#define VIDEO_SCH		        "video_schedule"
#define VIDEO_DEF1		        "video_define1"
#define VIDEO_DEF2		        "video_define2"
#define VIDEO_DEF3		        "video_define3"
#define VIDEO_DEF4		        "video_define4"
#define VIDEO_DEF5		        "video_define5"
#define VIDEO_DEF6		        "video_define6"
#define VIDEO_DEF7		        "video_define7"
#define VIDEO_DEF8		        "video_define8"
#define VIDEO_DEF9		        "video_define9"
#define VIDEO_DEF10		        "video_define10"

#define VIDEO_TIMESTAMP		    "time_stamp"
#define VIDEO_TEXT_OVERLAY	    "text_overlay"
#define VIDEO_TEXT		        "text"

#ifdef _HAS_IMAGE_OVERLAY_
#define VIDEO_IMAGE_OVERLAY     "image_overlay"
#define VIDEO_IMAGE_OPTION		"image_option"
#define VIDEO_IMAGE_POSITION    "image_position"
#define VIDEO_IMAGE_TRANSPARENT "image_transparent"
#define VIDEO_IMAGE_TRANS_COLOR "image_trans_color"
#define VIDEO_MASK_WINDOW1      "mask_window1"
#define VIDEO_MASK_WINDOW2      "mask_window2"
#define VIDEO_MASK_WINDOW3      "mask_window3"
#define VIDEO_MASK_WINDOW4      "mask_window4"
#define VIDEO_MASK_POSITION1    "mask_position1"
#define VIDEO_MASK_POSITION2    "mask_position2"
#define VIDEO_MASK_POSITION3    "mask_position3"
#define VIDEO_MASK_POSITION4    "mask_position4"
#define VIDEO_MASK_COLOR1       "mask_color1"
#define VIDEO_MASK_COLOR2       "mask_color2"
#define VIDEO_MASK_COLOR3       "mask_color3"
#define VIDEO_MASK_COLOR4       "mask_color4"
#endif

#define VIDEO_POWER_LINE	    		"power_line"
#define VIDEO_COLOR		       		 	"color"
#define VIDEO_EXPOSURE		    		"exposure"
#define VIDEO_SHARPNESS		    		"sharpness"
#define VIDEO_FLIP                      "flip"
#define	VIDEO_MIRROR		    		"mirror"
#define VIDEO_HUE						"hue"
#define VIDEO_SATURATION				"saturation"
#define VIDEO_CONTRAST					"contrast"
#define VIDEO_DN_FILTER                 "dn_filter"
#define VIDEO_DN_SCHEDULE_ENABLE        "dn_sch"
#define VIDEO_DN_SCHEDULE_STATR_HR      "dn_sch_hr"
#define VIDEO_DN_SCHEDULE_STATR_MIN     "dn_sch_min"
#define VIDEO_DN_SCHEDULE_END_HR        "dn_hrend"
#define VIDEO_DN_SCHEDULE_END_MIN       "dn_minend"

#define SEC_MPEG4           "MPEG4"
#define MPEG4_RES               "resolution"
#define MPEG4_QUAL_TYPE         "quality_type"
#define MPEG4_QUAL_LEVEL        "quality_level"
#define MPEG4_BITRATE           "bit_rate"
#define MPEG4_FRAMERATE         "frame_rate"
#define MPEG4_BANDWIDTH         "bandwidth"

#define SEC_JPEG			"JPEG"
#define JPEG_RES                "resolution"
#define JPEG_QUAL_LEVEL         "quality_level"
#define JPEG_FRAMERATE          "frame_rate"
#define JPEG_BANDWIDTH          "bandwidth"


#define SEC_MOBILE          "MOBILE"
#define MOBILE_SUPPORT          "mobile_support"
#define MOBILE_RES              "resolution"
#define MOBILE_QUAL_TYPE        "quality_type"
#define MOBILE_QUAL_LEVEL       "quality_level"
#define MOBILE_BITRATE          "bit_rate"
#define MOBILE_FRAMERATE        "frame_rate"
#define MOBILE_ACCESS           "mobile_access"

#define SEC_AUDIO			"AUDIO"
#define MIC_IN_SUPPORT			"audio_in"
#define MIC_IN_VOLUME			"in_volume"
#define MIC_IN_TYPE				"in_audio_type"
#define SPEAKER_OUT_SUPPORT		"audio_out"
#define SPEAKER_OUT_VOLUME		"out_volume"
#define SPEAKER_OUT_TYPE		"out_audio_type"
#define AUDIO_MODE				"audio_mode"
#define OPERATION_MODE			"operation_mode"

#define SEC_USER		    "USER"
#define USER_LOGIN_CHECK	    "login_check"
#define USER_ADMIN_TIMEOUT	    "admin_timeout"
#define USER_ADMIN_NAME		    "admin_name"
#define USER_ADMIN_PASSWORD	    "admin_password"

#ifdef _HAS_VIEWER_ACCOUNT_
#define USER_VIEWER_NAME		"viewer_name"
#define USER_VIEWER_PASSWORD	"viewer_password"
#endif

/* Convenient to write the program, 
please offer the string format */

#define USER_USER_FORMAT	    "user%d"

#define USER_USER1		        "user1"
#define USER_USER2		        "user2"
#define USER_USER3		        "user3"
#define USER_USER4		        "user4"
#define USER_USER5		        "user5"
#define USER_USER6		        "user6"
#define USER_USER7		        "user7"
#define USER_USER8		        "user8"
#define USER_USER9		        "user9"
#define USER_USER10		        "user10"
#define USER_USER11		        "user11"
#define USER_USER12		        "user12"
#define USER_USER13		        "user13"
#define USER_USER14		        "user14"
#define USER_USER15		        "user15"
#define USER_USER16		        "user16"
#define USER_USER17		        "user17"
#define USER_USER18		        "user18"
#define USER_USER19		        "user19"
#define USER_USER20		        "user20"
#define USER_AUDIO_IN_CTRL	    "audio_in_ctrl"
#define USER_AUDIO_OUT_CTRL	    "audio_out_ctrl"
#define USER_PT_CTRL		    "pt_ctrl"
#define USER_IO_CTRL		    "io_ctrl"
#define USER_ADM_CTRL		    "adm_ctrl"

#define SEC_IPFILTER		"IP_FILTER"
#define IPFILTER_EN		        "ip_filter"
#define IPFILTER_RULE		    "ip_filter_rule"
#define IPFILTER_1		        "ip_filter1"
#define IPFILTER_2		        "ip_filter2"
#define IPFILTER_3		        "ip_filter3"
#define IPFILTER_4		        "ip_filter4"
#define IPFILTER_5		        "ip_filter5"
#define IPFILTER_6		        "ip_filter6"
#define IPFILTER_7		        "ip_filter7"
#define IPFILTER_8		        "ip_filter8"
#define IPFILTER_9		        "ip_filter9"
#define IPFILTER_10		        "ip_filter10"
#define IPFILTER_11		        "ip_filter11"
#define IPFILTER_12		        "ip_filter12"
#define IPFILTER_13		        "ip_filter13"
#define IPFILTER_14		        "ip_filter14"
#define IPFILTER_15		        "ip_filter15"
#define IPFILTER_16		        "ip_filter16"
#define IPFILTER_17		        "ip_filter17"
#define IPFILTER_18		        "ip_filter18"
#define IPFILTER_19		        "ip_filter19"
#define IPFILTER_20		        "ip_filter20"



#define SEC_MOTION		    "MOTION"
#define MOTION_MODE		        "md_mode"
#define MOTION_SWITCH1		    "md_switch1"
#define MOTION_SWITCH2		    "md_switch2"
#define MOTION_SWITCH3		    "md_switch3"
#define MOTION_SWITCH4		    "md_switch4"
#define MOTION_NAME1		    "md_name1"
#define MOTION_NAME2		    "md_name2"
#define MOTION_NAME3		    "md_name3"
#define MOTION_NAME4		    "md_name4"
#define MOTION_WINDOW1		    "md_window1"
#define MOTION_WINDOW2		    "md_window2"
#define MOTION_WINDOW3		    "md_window3"
#define MOTION_WINDOW4		    "md_window4"
#define MOTION_THRESHOLD1	    "md_threshold1"
#define MOTION_THRESHOLD2	    "md_threshold2"
#define MOTION_THRESHOLD3	    "md_threshold3"
#define MOTION_THRESHOLD4	    "md_threshold4"
#define MOTION_SENSITIVITY1	    "md_sensitivity1"
#define MOTION_SENSITIVITY2	    "md_sensitivity2"
#define MOTION_SENSITIVITY3	    "md_sensitivity3"
#define MOTION_SENSITIVITY4	    "md_sensitivity4"

#ifdef _HAS_SERIAL_
#define SEC_COM			"SERIAL"
#define COM_MODE			"SerialMode"
#define COM_ADDRESS			"RS485Addr"
#define COM_BAUD			"BaudRate"
#define COM_DATA			"DataBit"
#define COM_STOP			"StopBit"
#define COM_PARITY			"Parity"
#define COM_FLOW_CTRL		"FlowControl"
#endif

#ifdef _HAS_PTZ_
#define SEC_PTZ			"PTZ"
#define PTZ_MODE			"PtzMode"

#define PTZ_NAME_FORMAT		"Preset%dName"
#define PTZ_NAME1			"Preset1Name"
#define PTZ_NAME2			"Preset2Name"
#define PTZ_NAME3			"Preset3Name"
#define PTZ_NAME4			"Preset4Name"
#define PTZ_NAME5			"Preset5Name"
#define PTZ_NAME6			"Preset6Name"
#define PTZ_NAME7			"Preset7Name"
#define PTZ_NAME8			"Preset8Name"
#define PTZ_NAME9			"Preset9Name"

#define PTZ_POSITION_FORMAT	"Preset%dPosition"

#define PTZ_POSITION1		"Preset1Position"
#define PTZ_POSITION2		"Preset2Position"
#define PTZ_POSITION3		"Preset3Position"
#define PTZ_POSITION4		"Preset4Position"
#define PTZ_POSITION5		"Preset5Position"
#define PTZ_POSITION6		"Preset6Position"
#define PTZ_POSITION7		"Preset7Position"
#define PTZ_POSITION8		"Preset8Position"
#define PTZ_POSITION9		"Preset9Position"
#define PTZ_PATROL1			"Patrol1Position"
#define PTZ_HOME			"PredefineHome"
#define PTZ_PANSPEED		"PtzPanSpeed"
#define PTZ_TILTSPEED		"PtzTiltSpeed"
#endif

#define SEC_IO			"IO"
#define IO_IN1_TRIGGER		"in1_trigger"
#define IO_IN2_TRIGGER		"in2_trigger"
#define IO_IN1_TYPE			"in1_type"
#define IO_IN2_TYPE			"in2_type"
#define IO_OUT1_INIT		"out1_init"
#define IO_OUT2_INIT		"out2_init"
#define IO_OUT1_BUTTON		"out1_button"
#define IO_OUT2_BUTTON		"out2_button"
#define IO_OUT1_ACTION		"out1_action"
#define IO_OUT2_ACTION		"out2_action"
#define IO_OUT1_PULSE_DUR	"out1_pulse_duration"
#define IO_OUT2_PULSE_DUR	"out2_pulse_duration"

#define EVENT_NAME_FORMAT	    "event_define%d"
#define SEC_EVENT		    "EVENT"
#define EVENT_TRIGGER		    "event_trigger"
#define EVENT_SCHEDULE		    "event_schedule"
#define EVENT_DEF1		        "event_define1"
#define EVENT_DEF2		        "event_define2"
#define EVENT_DEF3		        "event_define3"
#define EVENT_DEF4		        "event_define4"
#define EVENT_DEF5		        "event_define5"
#define EVENT_DEF6		        "event_define6"
#define EVENT_DEF7		        "event_define7"
#define EVENT_DEF8		        "event_define8"
#define EVENT_DEF9		        "event_define9"
#define EVENT_DEF10		        "event_define10"
#define EVENT_INTERVAL	    	"event_interval"
#define EVENT_IN1		        "event_in1"
#define EVENT_IN2		        "event_in2"
#define EVENT_MOTION		    "event_mt"
#define EVENT_ATTACH		    "event_attach"
#define EVENT_MPEG4		        "event_mpeg4"
#define EVENT_JPEG		        "event_jpeg"

#ifdef _HAS_VIDEO_LOG_
#define EVENT_FILE_OVERWRITE_ENABLE	"event_file_overwrite_enable"
#endif

#ifdef _SC_CHANGE_EVENT_FILENAME_
#define EVENT_FILENAME	        "filename"
#define EVENT_FILETYPE	        "filetype"
#define EVENT_SEQNUM	        "seqnum"
#endif

#define SEC_QOS			    "QOS"
#define QOS_ENABLE		"qos_enable"
#define QOS_DSCP		"qos_dscp"
#define QOS_AV_SWITCH	"qos_av_switch"
#ifdef _HAS_COS_
#define COS_ENABLE		"cos_enable"
#define COS_PRIORITY	"cos_priority"
#define COS_VLAN_ID		"cos_vlan_id"
#endif

//put here for temp,must be moved to other file.

#if 0
#define SC_LAN_CONN_TYPE_WIRELESS	"Wireless"
#define SC_LAN_CONN_TYPE_ETHERNET	"Ethernet"

#define WLAN_SECURITY_DISABLED		"Disabled"
#define WLAN_SECURITY_WEP			"WEP"
#define WLAN_SECURITY_WPA_PSK		"WPA-PSK"
#define WLAN_SECURITY_WPA2_ENTERPRISE		"WPA2-Enterprise"
#define WLAN_WEPKEY_128B_VALUE_DEF			"00000000000000000000000000"
#define WLAN_WEPKEY_64B_VALUE_DEF			"0000000000"
#endif 

#endif


