/***************************************************************
* (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "ntp.h"
#include "SYS_log.h"
#include "conf_sec.h"
#include "ntp_config.h"

#ifdef _USER_SETNTP_
static int GetServer(char *server){
	FILE *fd;
	int ret;

	fd = fopen(SYSTEM_CONF,"rt");
	if(fd==NULL){
		return -1;
        }

	ret = NPRO_GetStr(SEC_SYS, SYS_NTP_SERVER, server, 50,fd);	
	if (ret != 0) {
		fclose(fd);
		return -1;
	}

	fclose(fd);

	return 0;
}
#endif

int main(int argc,char *argv[]){

#ifdef _USER_SETNTP_
	struct hostent *h;
#endif
	char addr[16];
	//int ret,DayLflag=0;
	int ret;
 	char server[NTP_ADDR_LEN+1];

	memset(server,0,sizeof(server));
	if(argc == 1) {

#ifdef _USER_SETNTP_
	     GetServer(server);
#endif
	} else if(argc == 2){
#ifdef _USER_SETNTP_
		 strcpy(server,argv[1]);
#endif
	} else	{
		exit(1);	
	}	

#ifdef _USER_SETNTP_
	if(!(h=gethostbyname(server))){
	    AddLog(SYSLOG_SECTION_NTP,SYSLOG_WARNING,2);
	     exit(1);
	}
	strcpy(addr,inet_ntoa(*((struct in_addr*)h->h_addr)));
#endif

	ret=NTP_update(addr);
#ifndef _USER_SETNTP_
	system("/usr/local/bin/ntp_setcron only_cron >/dev/null 2>/dev/null & ");
#endif

	return ret;
}
