#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/un.h>
#include <sys/uio.h>

#define		TRUE		1
#define		FALSE		0


#define USER_AGENT_MOZILLA	1	//"mozilla"
#define USER_AGENT_OCX		2	//"ocx"
#define USER_AGENT_IE		3	//"ie"
#define USER_AGENT_NONE		0	//"none"

#define VIDEO_TYPE_MJPEG	1	//"mjpeg"
#define VIDEO_TYPE_JPEG		2	//"jpeg"
#define VIDEO_TYPE_ASF		3	//"asf"
#define VIDEO_TYPE_3GP		4	//"3gp"
#define VIDEO_TYPE_SAV		5	//"sav"

#define RESOLUTION_160_128	3	//"160x128"
#define RESOLUTION_320_240	2	//"320x240"
#define RESOLUTION_640_480	1	//"640x480"
#define RESOLUTION_NONE		0	//"none"

#define RESOLUTION_UI_INDEX_160_128	1
#define RESOLUTION_UI_INDEX_320_240	2
#define RESOLUTION_UI_INDEX_640_480	3
#define RESOLUTION_UI_INDEX_NONE	0

#define QUALITY_VERY_LOW	1	//"1"
#define QUALITY_LOW			2	//"2"
#define QUALITY_NORMAL		3	//"3"
#define QUALITY_HIGH		4	//"4"
#define QUALITY_VERY_HIGH	5	//"5"
#define QUALITY_NONE	0	//"NULL"

#define REQ_METHOD_GET		1
#define REQ_METHOD_POST		0	

typedef struct {
	char ip[32];			// ip address for the log file
	unsigned short port;		// port for the log file
	char name[32];			// user name for the log file
	int method;		// 0 post, 1 get
	unsigned short agent;			// user agent for the MJPEG server push - "mozilla", "ocx" and "ie"
	unsigned short video_type;	// video type - "mjpeg", "mpeg" and "3gp"
	char x_session_cookie[32];	// for rtp/rtsp over http
	char post_data[1024];
	int post_data_len;
	int  resolution;		// // resolution - 1=160x128, 2=320x240 and 3=640x480
	int quality;		// quality - very low to very high - "1" to "5"
	int framerate;		// 1-30
} client_message;

int pass_fd(int s);
int send_fd(int s, int fd, void *addr, socklen_t alen8);

int recv_fd_and_message (int s, client_message *pmsg);

//int pass_fd_and_message(int fd, char *usr_msg);
int pass_fd_and_message(int fd, client_message *p_msg);
